SystemOrganization addCategory: 'MonticelloFileTree-Core'!

!Dictionary methodsFor: '*monticellofiletree-core' stamp: 'dkh 4/6/2012 15:56:14'!
writeCypressJsonForHtmlOn: aStream
    self writeCypressJsonOn: aStream forHtml: true indent: 0! !

!Dictionary methodsFor: '*monticellofiletree-core' stamp: 'dkh 4/6/2012 15:56:14'!
writeCypressJsonOn: aStream
    self writeCypressJsonOn: aStream forHtml: false indent: 0.
    aStream lf! !

!Dictionary methodsFor: '*monticellofiletree-core' stamp: 'dkh 4/6/2012 15:56:14'!
writeCypressJsonOn: aStream forHtml: forHtml indent: startIndent
    "by default ignore <forHtml> ... <forHtml> is used for Dictionary and Array, i.e., container objects and String which actually encodes itself differently for HTML"

    | indent keys |
    indent := startIndent.
    aStream
        nextPutAll: '{';
        lf.
    indent := indent + 1.
    keys := self keys sort: [ :a :b | a <= b ].
    1 to: keys size do: [ :index | 
        | key value |
        key := keys at: index.
        value := self at: key.
        aStream tab: indent.
        key writeCypressJsonOn: aStream forHtml: forHtml indent: indent.
        aStream nextPutAll: ' : '.
        value writeCypressJsonOn: aStream forHtml: forHtml indent: indent.
        index < self size
            ifTrue: [ 
                aStream
                    nextPutAll: ',';
                    lf ] ].
    self size = 0
        ifTrue: [ aStream tab: indent ].
    aStream nextPutAll: ' }'! !

!Number methodsFor: '*monticellofiletree-core' stamp: 'dkh 4/6/2012 15:56:14'!
writeCypressJsonOn: aStream forHtml: forHtml indent: startIndent
    "by default ignore <forHtml> ... <forHtml> is used for Dictionary and Array, i.e., container objects and String which actually encodes itself differently for HTML"

    aStream nextPutAll: self printString! !

!String methodsFor: '*monticellofiletree-core' stamp: 'dkh 4/6/2012 15:56:14'!
cypressEscape
    ^ self encodeForHTTP! !

!String methodsFor: '*monticellofiletree-core' stamp: 'dkh 4/6/2012 15:56:14'!
cypressUnescape
    ^ self unescapePercents! !

!String methodsFor: '*monticellofiletree-core' stamp: 'dkh 4/6/2012 15:56:14'!
writeCypressJsonOn: aStream forHtml: forHtml indent: startIndent
    "by default ignore <forHtml> ... <forHtml> is used for Dictionary and Array, i.e., container objects and String which actually encodes itself differently for HTML"

    aStream
        nextPutAll: '"';
        nextPutAll:
                (forHtml
                        ifTrue: [ self cypressEscape ]
                        ifFalse: [ self ]);
        nextPutAll: '"'! !

MCDirectoryRepository subclass: #MCFileTreeRepository
	instanceVariableNames: 'readonly repositoryProperties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

MCFileTreeRepository class
	instanceVariableNames: 'defaultPackageExtension'!

!MCFileTreeRepository class methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
defaultPackageExtension
    ".tree, .pkg, .package are the only formats supported at the moment:
	.tree         - original structure
	.pkg          - snapshot structure
	.package - cypress structure"

    defaultPackageExtension
        ifNil: [ 
            defaultPackageExtension := MCFileTreePackageStructureStWriter useCypressWriter
                ifTrue: [ '.package' ]
                ifFalse: [ '.pkg' ] ].
    ^ defaultPackageExtension! !

!MCFileTreeRepository class methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
defaultPackageExtension: aString
    ".tree and .pkg are the only two formats supported at the moment"

    "self defaultPackageExtension:'.package'"

    (#('.tree' '.pkg' '.package') includes: aString)
        ifFalse: [ self error: 'Unsupported package extension: ' , aString printString ].
    defaultPackageExtension := aString! !

!MCFileTreeRepository class methodsFor: 'instance creation' stamp: 'dkh 4/5/2012 11:15:15'!
description
    ^ 'filetree://'! !

!MCFileTreeRepository class methodsFor: 'utility' stamp: 'dkh 4/5/2012 11:15:15'!
parseName: aString
    ^ self parseName: aString extension: self defaultPackageExtension! !

!MCFileTreeRepository class methodsFor: 'utility' stamp: 'dkh 4/5/2012 11:15:15'!
parseName: aString extension: extension
    "picked up from GoferVersionReference>>parseName:"

    | info basicName package branch author versionNumber packageName |
    basicName := aString last isDigit
        ifTrue: [ aString ]
        ifFalse: [ (aString copyUpToLast: $.) copyUpTo: $( ].
    package := basicName copyUpToLast: $-.
    (package includes: $.)
        ifFalse: [ branch := '' ]
        ifTrue: [ 
            branch := '.' , (package copyAfter: $.).
            package := package copyUpTo: $. ].
    author := (basicName copyAfterLast: $-) copyUpToLast: $..
    versionNumber := (basicName copyAfterLast: $-) copyAfterLast: $..
    (versionNumber notEmpty and: [ versionNumber allSatisfy: [ :each | each isDigit ] ])
        ifTrue: [ versionNumber := versionNumber asNumber ]
        ifFalse: [ versionNumber := 0 ].
    packageName := package , branch.
    ^ {packageName.
    author.
    versionNumber.
    (packageName , extension)}! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'ezra 10/28/2011 19:24'!
allFileNames
	^(directory entries select: [:entry | entry isDirectory and: [self canReadFileNamed: entry name]]) collect: [:entry | entry name]! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'ezra 10/28/2011 18:41'!
allFileNamesForVersionNamed: aString
	^ {(self treeDirectoryNameForVersionNamed: aString)}! !

!MCFileTreeRepository methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
asRepositorySpecFor: aMetacelloMCProject
    ^ aMetacelloMCProject repositorySpec
        description: self description;
        type: 'filetree';
        yourself! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'dkh 4/5/2012 11:15:15'!
basicStoreVersion: aVersion
    self readonly
        ifTrue: [ ^ self error: 'The filetree repository: ' , self description printString , ' was created read only.' ].
    self packageExtension ~= self class defaultPackageExtension
        ifTrue: [ 
            repositoryProperties := nil.	"force reset of properties, since we're rewriting the file"
            self writeRepositoryProperties ].
    MCFileTreeWriter fileOut: aVersion on: self! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'OttoBehrens 10/25/2011 07:20'!
cachedFileNames
	^ #()! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'dkh 4/5/2012 11:15:15'!
canReadFileNamed: aString
    ^ (aString endsWith: self packageExtension) or: [ aString endsWith: '.tree' ]! !

!MCFileTreeRepository methodsFor: 'descriptions' stamp: 'dkh 4/5/2012 11:15:15'!
description
    ^ self class description , super description! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'dkh 4/5/2012 11:15:15'!
directory: aDirectory
    super directory: aDirectory.
    self repositoryProperties isEmpty
        ifTrue: [ 
            aDirectory exists
                ifTrue: [ self writeRepositoryProperties ] ]! !

!MCFileTreeRepository methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
directoryFrom: aDirectory
	self directory: (FileDirectory on: aDirectory)! !

!MCFileTreeRepository methodsFor: 'actions' stamp: 'OttoBehrens 10/25/2011 08:57'!
fileDirectoryOn: fileName
	^ FileDirectory on: (directory fullNameFor: fileName)! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'dkh 4/5/2012 11:15:15'!
goferVersionFrom: aVersionReference
    "until we no longer find .tree directories in the wild"

    ((self readableFileNames collect: [ :fileName | self fileDirectoryOn: fileName ])
        select: [ :packageDirectory | packageDirectory exists ])
        collect: [ :packageDirectory | 
            (self versionInfoForPackageDirectory: packageDirectory) name = aVersionReference name
                ifTrue: [ ^ self loadVersionFromFileNamed: packageDirectory localName ] ].
    ^ nil! !

!MCFileTreeRepository methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
metacelloProjectClass
    ^ MetacelloFileTreeProject! !

!MCFileTreeRepository methodsFor: 'actions' stamp: 'dkh 4/5/2012 11:15:15'!
packageDescriptionFromPackageDirectory: packageDirectory
    | filename info extension |
    filename := packageDirectory localName.
    extension := filename copyFrom: (filename lastIndexOf: $. ifAbsent: [ '' ]) to: filename size.
    info := self versionInfoForPackageDirectory: packageDirectory.
    ^ self parseName: info name extension: extension! !

!MCFileTreeRepository methodsFor: 'actions' stamp: 'ezra 10/28/2011 18:32'!
packageDescriptionsFromReadableFileNames
	^ ((self readableFileNames collect: [ :fileName | self fileDirectoryOn: fileName ])
		select: [ :packageDirectory | packageDirectory exists ])
		collect: [ :packageDirectory | self packageDescriptionFromPackageDirectory: packageDirectory ]! !

!MCFileTreeRepository methodsFor: 'private' stamp: 'dkh 4/5/2012 11:15:15'!
packageExtension
    ^ self repositoryProperties at: 'packageExtension' ifAbsent: [ '.tree' ]! !

!MCFileTreeRepository methodsFor: 'private' stamp: 'dkh 4/5/2012 11:15:15'!
parseName: aString extension: extension
    ^ self class parseName: aString extension: extension! !

!MCFileTreeRepository methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
readonly
    readonly ifNil: [ readonly := false ].
    ^ readonly! !

!MCFileTreeRepository methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
readonly: anObject
	readonly := anObject! !

!MCFileTreeRepository methodsFor: 'i/o' stamp: 'ezra 10/28/2011 18:53'!
readStreamForFileNamed: aString do: aBlock
	^ aBlock value: directory! !

!MCFileTreeRepository methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
repositoryProperties
    repositoryProperties
        ifNil: [ 
            repositoryProperties := Dictionary new.
            directory exists
                ifFalse: [ 
                    Transcript
                        cr;
                        show: 'filetree:// repository ' , directory pathName printString , ' does not exist.'.
                    ^ repositoryProperties ].
            (directory entries detect: [ :entry | entry name = '.filetree' ] ifNone: [  ])
                ifNotNil: [ :configEntry | 
                    configEntry
                        readStreamDo: [ :fileStream | 
                            [ repositoryProperties := MCFileTreeJsonParser parseStream: fileStream ]
                                on: Error
                                do: [ :ex | 
                                    Transcript
                                        cr;
                                        show:
                                                'Error reading repository properties (.filetree): ' , directory pathName , ' :: ' , ex description ] ] ] ].
    ^ repositoryProperties! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'dkh 1/30/2012 20:57'!
treeDirectoryNameForVersionNamed: aString
	^ (self class parseName: aString) last! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'OttoBehrens 10/25/2011 07:20'!
versionFromFileNamed: aString
	^ self loadVersionFromFileNamed: aString! !

!MCFileTreeRepository methodsFor: 'actions' stamp: 'dkh 4/5/2012 11:15:15'!
versionInfoForPackageDirectory: packageDirectory
    ^ ((MCReader readerClassForFileNamed: packageDirectory localName)
        on: packageDirectory containingDirectory
        fileName: packageDirectory localName)
        loadVersionInfo;
        info! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'OttoBehrens 10/25/2011 07:22'!
versionInfoFromFileNamed: aString
	^ self loadVersionInfoFromFileNamed: aString! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'ezra 10/28/2011 18:36'!
versionNameFromFileName: aString
	| description |
	description := self packageDescriptionFromPackageDirectory: (self fileDirectoryOn: aString).
	^ description first , '-' , description second , '.' , description third printString! !

!MCFileTreeRepository methodsFor: 'interface' stamp: 'OttoBehrens 10/26/2011 20:13'!
versionWithInfo: aVersionInfo ifAbsent: errorBlock
	(self allFileNamesForVersionNamed: aVersionInfo name)
		ifNotEmpty: [ :aCollection | ^ self versionFromFileNamed: aCollection first ].
	^ errorBlock value! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'dkh 4/5/2012 11:15:15'!
writeRepositoryProperties
    directory
        forceNewFileNamed: '.filetree'
        do: [ :file | 
            file lineEndConvention: #'lf'.
            file
                nextPutAll: '{ "packageExtension" : "' , self class defaultPackageExtension , '" }';
                cr ]! !

!MCFileTreeRepository methodsFor: 'i/o' stamp: 'OttoBehrens 10/26/2011 20:45'!
writeStreamForFileNamed: aString replace: aBoolean do: aBlock
	self error: 'we do not open a single stream, but write multiple files'! !

!Array methodsFor: '*monticellofiletree-core' stamp: 'dkh 4/6/2012 15:56:14'!
writeCypressJsonOn: aStream forHtml: forHtml indent: startIndent
    "by default ignore <forHtml> ... <forHtml> is used for Dictionary and Array, i.e., container objects and String which actually encodes itself differently for HTML"

    | indent |
    aStream
        nextPutAll: '[';
        lf.
    indent := startIndent + 1.
    1 to: self size do: [ :index | 
        | item |
        item := self at: index.
        aStream tab: indent.
        item writeCypressJsonOn: aStream forHtml: forHtml indent: indent.
        index < self size
            ifTrue: [ 
                aStream
                    nextPutAll: ',';
                    lf ] ].
    self size = 0
        ifTrue: [ aStream tab: indent ].
    aStream nextPutAll: ' ]'! !

Object subclass: #MCFileTreeJsonParser
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

!MCFileTreeJsonParser class methodsFor: 'instance creation' stamp: 'dkh 4/5/2012 11:15:15'!
new
	self error: 'Instantiate the parser with a stream.'! !

!MCFileTreeJsonParser class methodsFor: 'instance creation' stamp: 'dkh 4/5/2012 11:15:15'!
on: aStream
	^ self basicNew initializeOn: aStream! !

!MCFileTreeJsonParser class methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
parse: aString
	^ self parseStream: aString readStream! !

!MCFileTreeJsonParser class methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
parseStream: aStream
	^ (self on: aStream) parse! !

!MCFileTreeJsonParser methodsFor: 'adding' stamp: 'dkh 4/5/2012 11:15:15'!
addProperty: anAssociation to: anObject
	"Add the property anAssociation described with key and value to anObject. Subclasses might want to refine this implementation."
	
	^ anObject 
		add: anAssociation;
		yourself! !

!MCFileTreeJsonParser methodsFor: 'adding' stamp: 'dkh 4/5/2012 11:15:15'!
addValue: anObject to: aCollection
	"Add anObject to aCollection. Subclasses might want to refine this implementation."

	^ aCollection copyWith: anObject! !

!MCFileTreeJsonParser methodsFor: 'creating' stamp: 'dkh 4/5/2012 11:15:15'!
createArray
	"Create an empty collection. Subclasses might want to refine this implementation."

	^ Array new! !

!MCFileTreeJsonParser methodsFor: 'creating' stamp: 'dkh 4/5/2012 11:15:15'!
createFalse
	"Create the false literal. Subclasses might want to refine this implementation."
	
	^ false! !

!MCFileTreeJsonParser methodsFor: 'creating' stamp: 'dkh 4/5/2012 11:15:15'!
createNull
	"Create the null literal. Subclasses might want to refine this implementation."

	^ nil! !

!MCFileTreeJsonParser methodsFor: 'creating' stamp: 'dkh 4/5/2012 11:15:15'!
createNumber: aString
	"Create a number literal. Subclasses might want to refine this implementation."

	^ aString asNumber! !

!MCFileTreeJsonParser methodsFor: 'creating' stamp: 'dkh 4/5/2012 11:15:15'!
createObject
	"Create an empty object. Subclasses might want to refine this implementation."
	
	^ Dictionary new! !

!MCFileTreeJsonParser methodsFor: 'creating' stamp: 'dkh 4/5/2012 11:15:15'!
createProperty: aKey with: aValue
	"Create an empty attribute value pair. Subclasses might want to refine this implementation."
	
	^ aKey -> aValue! !

!MCFileTreeJsonParser methodsFor: 'creating' stamp: 'dkh 4/5/2012 11:15:15'!
createString: aString
	"Create a string literal. Subclasses might want to refine this implementation."

	^ aString! !

!MCFileTreeJsonParser methodsFor: 'creating' stamp: 'dkh 4/5/2012 11:15:15'!
createTrue
	"Create the true literal. Subclasses might want to refine this implementation."

	^ true! !

!MCFileTreeJsonParser methodsFor: 'private' stamp: 'dkh 4/5/2012 11:15:15'!
expect: aString
	"Expects aString and consume input, throw an error otherwise."

	^ (self match: aString) ifFalse: [ self error: aString , ' expected' ]! !

!MCFileTreeJsonParser methodsFor: 'initialization' stamp: 'dkh 4/5/2012 11:15:15'!
initializeOn: aStream
	self initialize.
	stream := aStream! !

!MCFileTreeJsonParser methodsFor: 'private' stamp: 'dkh 4/5/2012 11:15:15'!
match: aString
	"Tries to match aString, consume input and answer true if successful."
	
	| position |
	position := stream position.
	aString do: [ :each |
		(stream atEnd or: [ stream next ~= each ]) ifTrue: [ 
			stream position: position.
			^ false ] ].
	self whitespace.
	^ true! !

!MCFileTreeJsonParser methodsFor: 'parsing' stamp: 'dkh 4/5/2012 11:15:15'!
parse
	| result |
	result := self whitespace; parseValue.
	stream atEnd
		ifFalse: [ self error: 'end of input expected' ].
	^ result! !

!MCFileTreeJsonParser methodsFor: 'parsing' stamp: 'dkh 4/5/2012 11:15:15'!
parseArray
	| result |
	self expect: '['.
	result := self createArray.
	(self match: ']')
		ifTrue: [ ^ result ].
	[ stream atEnd ] whileFalse: [
		result := self
			addValue: self parseValue
			to: result.
		(self match: ']') 
			ifTrue: [ ^ result ].
		self expect: ',' ].
	self error: 'end of array expected'! !

!MCFileTreeJsonParser methodsFor: 'parsing-internal' stamp: 'dkh 4/5/2012 11:15:15'!
parseCharacter
	| char |
	(char := stream next) = $\ 
		ifFalse: [ ^ char ].
	(char := stream next) = $" 
		ifTrue: [ ^ char ].
	char = $\
		ifTrue: [ ^ char ].
	char = $/
		ifTrue: [ ^ char ].
	char = $b
		ifTrue: [ ^ Character backspace ].
	char = $f
		ifTrue: [ ^ Character newPage ].
	char = $n
		ifTrue: [ ^ Character lf ].
	char = $r
		ifTrue: [ ^ Character cr ].
	char = $t
		ifTrue: [ ^ Character tab ].
	char = $u
		ifTrue: [ ^ self parseCharacterHex ].
	self error: 'invalid escape character \' , (String with: char)! !

!MCFileTreeJsonParser methodsFor: 'parsing-internal' stamp: 'dkh 4/5/2012 11:15:15'!
parseCharacterHex
	| value |
	value := self parseCharacterHexDigit.
	3 timesRepeat: [ value := (value << 4) + self parseCharacterHexDigit ].
	^ Character codePoint: value! !

!MCFileTreeJsonParser methodsFor: 'parsing-internal' stamp: 'dkh 4/6/2012 15:56:14'!
parseCharacterHexDigit
    | digit |
    stream atEnd
        ifFalse: [ 
            digit := stream next charCode.
            (digit between: 48 and: 57)
                ifTrue: [ ^ digit - 48 ].	"$0"	"$9"
            (digit between: 65 and: 70)
                ifTrue: [ ^ digit - 55 ].	"$A"	"$F"
            (digit between: 97 and: 102)
                ifTrue: [ ^ digit - 87 ]	"$a"	"$f" ].
    self error: 'hex-digit expected'! !

!MCFileTreeJsonParser methodsFor: 'parsing-internal' stamp: 'dkh 4/5/2012 11:15:15'!
parseNumber
	| negated number |
	negated := stream peek = $-.
	negated ifTrue: [ stream next ].
	number := self parseNumberInteger.
	(stream peek = $.) ifTrue: [
		stream next. 
		number := number + self parseNumberFraction ].
	(stream peek = $e or: [ stream peek = $E ]) ifTrue: [
		stream next.
		number := number * self parseNumberExponent ].
	negated ifTrue: [ number := number negated ].
	^ self whitespace; createNumber: number! !

!MCFileTreeJsonParser methodsFor: 'parsing-internal' stamp: 'dkh 4/6/2012 15:56:14'!
parseNumberExponent
    | number negated |
    number := 0.
    negated := stream peek = $-.
    (negated or: [ stream peek = $+ ])
        ifTrue: [ stream next ].
    [ stream atEnd not and: [ stream peek isDigit ] ] whileTrue: [ number := 10 * number + (stream next charCode - 48) ].
    negated
        ifTrue: [ number := number negated ].
    ^ 10 raisedTo: number! !

!MCFileTreeJsonParser methodsFor: 'parsing-internal' stamp: 'dkh 4/6/2012 15:56:14'!
parseNumberFraction
    | number power |
    number := 0.
    power := 1.0.
    [ stream atEnd not and: [ stream peek isDigit ] ]
        whileTrue: [ 
            number := 10 * number + (stream next charCode - 48).
            power := power * 10.0 ].
    ^ number / power! !

!MCFileTreeJsonParser methodsFor: 'parsing-internal' stamp: 'dkh 4/6/2012 15:56:14'!
parseNumberInteger
    | number |
    number := 0.
    [ stream atEnd not and: [ stream peek isDigit ] ] whileTrue: [ number := 10 * number + (stream next charCode - 48) ].
    ^ number! !

!MCFileTreeJsonParser methodsFor: 'parsing' stamp: 'dkh 4/5/2012 11:15:15'!
parseObject
	| result |
	self expect: '{'.
	result := self createObject.
	(self match: '}')
		ifTrue: [ ^ result ].
	[ stream atEnd ] whileFalse: [
		result := self
			addProperty: self parseProperty
			to: result.
		(self match: '}')
			ifTrue: [ ^ result ].
		self expect: ',' ].
	self error: 'end of object expected'! !

!MCFileTreeJsonParser methodsFor: 'parsing-internal' stamp: 'dkh 4/5/2012 11:15:15'!
parseProperty
	| name value |
	name := self parseString.
	self expect: ':'.
	value := self parseValue.
	^ self createProperty: name with: value.! !

!MCFileTreeJsonParser methodsFor: 'parsing-internal' stamp: 'dkh 4/5/2012 11:15:15'!
parseString
	| result |
	self expect: '"'.
	result := WriteStream on: String new.
	[ stream atEnd or: [ stream peek = $" ] ] 
		whileFalse: [ result nextPut: self parseCharacter ].
	^ self expect: '"'; createString: result contents! !

!MCFileTreeJsonParser methodsFor: 'parsing' stamp: 'dkh 4/5/2012 11:15:15'!
parseValue
	| char |
	stream atEnd ifFalse: [ 
		char := stream peek.
		char = ${
			ifTrue: [ ^ self parseObject ].
		char = $[
			ifTrue: [ ^ self parseArray ].
		char = $"
			ifTrue: [ ^ self parseString ].
		(char = $- or: [ char between: $0 and: $9 ])
			ifTrue: [ ^ self parseNumber ].
		(self match: 'true')
			ifTrue: [ ^ self createTrue ].
		(self match: 'false')
			ifTrue: [ ^ self createFalse ].
		(self match: 'null')
			ifTrue: [ ^ self createNull ] ].
	self error: 'invalid input'! !

!MCFileTreeJsonParser methodsFor: 'private' stamp: 'dkh 4/5/2012 11:15:15'!
whitespace
	"Strip whitespaces from the input stream."

	[ stream atEnd not and: [ stream peek isSeparator ] ]
		whileTrue: [ stream next ]! !

!Object methodsFor: '*monticellofiletree-core' stamp: 'dkh 4/6/2012 15:56:14'!
writeCypressJsonForHtmlOn: aStream indent: startIndent
    self writeCypressJsonOn: aStream forHtml: true indent: startIndent! !

!Object methodsFor: '*monticellofiletree-core' stamp: 'dkh 4/6/2012 15:56:14'!
writeCypressJsonOn: aStream forHtml: forHtml indent: startIndent
    "by default ignore <forHtml> ... <forHtml> is used for Dictionary and Array, i.e., container objects and String which actually encodes itself differently for HTML"

    ^ self subclassResponsibility! !

!Object methodsFor: '*monticellofiletree-core' stamp: 'dkh 4/6/2012 15:56:14'!
writeCypressJsonOn: aStream indent: startIndent
    self writeCypressJsonOn: aStream forHtml: false indent: startIndent! !

MCMczWriter subclass: #MCFileTreeWriter
	instanceVariableNames: 'directory packageFileDirectory cachedPackageFileDirectoryEntries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

!MCFileTreeWriter class methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
readerClass
    "don't expect this message to be sent"

    self shouldNotImplement! !

!MCFileTreeWriter methodsFor: 'writing' stamp: 'dkh 4/5/2012 11:15:15'!
addString: string at: fileName
    | path |
    path := MCFileTreePackageStructureStWriter useCypressWriter
        ifTrue: [ 
            self packageFileDirectory assureExistenceOfPath: MCFileTreeStCypressWriter monticelloMetaDirName.
            MCFileTreeStCypressWriter monticelloMetaDirName , '/' , fileName ]
        ifFalse: [ fileName ].
    string isEmpty
        ifFalse: [ self packageFileDirectory forceNewFileNamed: path do: [ :file | file nextPutAll: string ] ]! !

!MCFileTreeWriter methodsFor: 'visiting' stamp: 'dkh 4/5/2012 11:15:15'!
deleteExistingPackageStructureFor: members
    "destroy .tree and .pkg directory structure .. otherwise it won't be pretty"

    | alternateDirName alternateDir |
    self packageFileDirectory exists
        ifTrue: [ self packageFileDirectory recursiveDelete ].
    alternateDirName := (self packageFileDirectory localName endsWith: '.pkg')
        ifTrue: [ members first , '.tree' ]
        ifFalse: [ 
            (self packageFileDirectory localName endsWith: '.tree')
                ifTrue: [ members first , '.pkg' ]
                ifFalse: [ 
                    (self packageFileDirectory localName endsWith: '.package')
                        ifTrue: [ members first , '.pkg' ] ] ].
    alternateDirName
        ifNotNil: [ 
            alternateDir := stream directory directoryNamed: alternateDirName.
            alternateDir exists
                ifTrue: [ alternateDir recursiveDelete ] ]! !

!MCFileTreeWriter methodsFor: 'writing' stamp: 'OttoBehrens 10/24/2011 21:34'!
flush
	! !

!MCFileTreeWriter methodsFor: 'visiting' stamp: 'ezra 10/25/2011 16:53'!
initializePackageFileDirectoryCache
	cachedPackageFileDirectoryEntries := Dictionary new.
	self packageFileDirectory entries
		do: [ :entry | 
			entry isDirectory
				ifTrue: [ cachedPackageFileDirectoryEntries at: entry name put: entry asFileDirectory ] ]! !

!MCFileTreeWriter methodsFor: 'writing' stamp: 'dkh 4/5/2012 11:15:15'!
packageFileDirectory
    packageFileDirectory ifNil: [ packageFileDirectory := stream directory directoryNamed: directory ].
    ^ packageFileDirectory! !

!MCFileTreeWriter methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
snapshotWriterClass
	^ MCFileTreeAbstractStWriter! !

!MCFileTreeWriter methodsFor: 'visiting' stamp: 'dkh 4/5/2012 11:15:15'!
subPackageFileDirectoryFor: directoryNameOrPath
    ^ cachedPackageFileDirectoryEntries
        at: directoryNameOrPath
        ifAbsentPut: [ 
            | dir |
            dir := self packageFileDirectory directoryNamed: directoryNameOrPath.
            dir assureExistence.
            dir ]! !

!MCFileTreeWriter methodsFor: 'visiting' stamp: 'OttoBehrens 10/25/2011 10:15'!
writeSnapshot: aSnapshot
	(self snapshotWriterClass on: self) writeDefinitions: aSnapshot definitions! !

!MCFileTreeWriter methodsFor: 'visiting' stamp: 'dkh 4/5/2012 11:15:15'!
writeVersion: aVersion
    | members |
    directory := (members := MCFileTreeRepository parseName: aVersion info name) last.
    self deleteExistingPackageStructureFor: members.
    self packageFileDirectory assureExistence.
    self initializePackageFileDirectoryCache.
    super writeVersion: aVersion! !

MCWriter subclass: #MCFileTreeAbstractStWriter
	instanceVariableNames: 'stWriter initializers orderedClassNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

!MCFileTreeAbstractStWriter class methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
monticelloMetaDirName
    ^ '.'! !

!MCFileTreeAbstractStWriter class methodsFor: 'writing' stamp: 'dkh 4/5/2012 11:15:15'!
on: aStream
    MCFileTreePackageStructureStWriter useCypressWriter
        ifTrue: [ ^ MCFileTreeStCypressWriter new stream: aStream ].
    ^ (MCFileTreePackageStructureStWriter useSnapShotWriter
        ifTrue: [ MCFileTreeStSnapshotWriter ]
        ifFalse: [ MCFileTreeStWriter ]) new stream: aStream! !

!MCFileTreeAbstractStWriter class methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
readerClass
	^ MCStReader! !

!MCFileTreeAbstractStWriter methodsFor: 'private' stamp: 'dkh 4/5/2012 11:15:15'!
directoryForDirectoryNamed: directoryNameOrPath
    ^ directoryNameOrPath = '.'
        ifTrue: [ stream packageFileDirectory ]
        ifFalse: [ stream subPackageFileDirectoryFor: directoryNameOrPath ]! !

!MCFileTreeAbstractStWriter methodsFor: 'private' stamp: 'dkh 4/5/2012 11:15:15'!
fileNameForSelector: selector
    ^ (selector == #'/'
        ifTrue: [ 'encoded slash' ]
        ifFalse: [ 
            (selector includes: $/)
                ifTrue: [ 'encoded' , selector copyReplaceAll: '/' with: ' slash ' ]
                ifFalse: [ selector ] ]) asString! !

!MCFileTreeAbstractStWriter methodsFor: 'initialize-release' stamp: 'dkh 4/5/2012 11:15:15'!
initialize
    stWriter := MCFileTreePackageStructureStWriter new
        initializers: (initializers := Set new);
        yourself.
    orderedClassNames := OrderedCollection new! !

!MCFileTreeAbstractStWriter methodsFor: 'private' stamp: 'dkh 4/5/2012 11:15:15'!
monticelloMetaDirName
    ^ self class monticelloMetaDirName! !

!MCFileTreeAbstractStWriter methodsFor: 'private' stamp: 'dkh 4/5/2012 11:15:15'!
setFileStream: file
    stWriter stream: file! !

!MCFileTreeAbstractStWriter methodsFor: 'visiting' stamp: 'dkh 4/5/2012 11:15:15'!
visitClassDefinition: definition
    self subclassResponsibility! !

!MCFileTreeAbstractStWriter methodsFor: 'visiting' stamp: 'dkh 4/5/2012 11:15:15'!
visitClassTraitDefinition: definition
    self flag: #'skippedForNow'! !

!MCFileTreeAbstractStWriter methodsFor: 'visiting' stamp: 'dkh 4/5/2012 11:15:15'!
visitMetaclassDefinition: definition
    "handled by class definition"

! !

!MCFileTreeAbstractStWriter methodsFor: 'visiting' stamp: 'dkh 4/5/2012 11:15:15'!
visitMethodDefinition: definition
    self subclassResponsibility! !

!MCFileTreeAbstractStWriter methodsFor: 'visiting' stamp: 'dkh 4/5/2012 11:15:15'!
visitOrganizationDefinition: defintion
    self
        writeInDirectoryName: self monticelloMetaDirName
        fileName: 'categories'
        extension: '.st'
        visit: [ defintion categories do: [ :cat | stWriter writeCategory: cat ] ]! !

!MCFileTreeAbstractStWriter methodsFor: 'visiting' stamp: 'dkh 4/5/2012 11:15:15'!
visitScriptDefinition: definition
    self flag: #'skippedForNow'! !

!MCFileTreeAbstractStWriter methodsFor: 'visiting' stamp: 'dkh 4/5/2012 11:15:15'!
visitTraitDefinition: definition
    self flag: #'skippedForNow'! !

!MCFileTreeAbstractStWriter methodsFor: 'initialize-release' stamp: 'dkh 4/5/2012 11:15:15'!
writeBasicDefinitions: aCollection
    "the correct initialization order is unknown if some classes are missing in the image"

    self writePropertiesFile.
    stWriter acceptVisitor: self forDefinitions: aCollection.
    self writeInitializers! !

!MCFileTreeAbstractStWriter methodsFor: 'writing' stamp: 'dkh 4/5/2012 11:15:15'!
writeClassDefinition: definition
    stWriter writeClassDefinition: definition.
    definition hasClassInstanceVariables
        ifTrue: [ stWriter writeMetaclassDefinition: definition ].
    definition hasComment
        ifTrue: [ stWriter writeClassComment: definition ]! !

!MCFileTreeAbstractStWriter methodsFor: 'initialize-release' stamp: 'dkh 4/5/2012 11:15:15'!
writeDefinitions: aCollection
    "the correct initialization order is unknown if some classes are missing in the image"

    self writeBasicDefinitions: aCollection! !

!MCFileTreeAbstractStWriter methodsFor: 'visiting' stamp: 'dkh 4/5/2012 11:15:15'!
writeInDirectoryName: directoryNameOrPath fileName: fileName extension: ext visit: visitBlock
    | directory |
    directory := self directoryForDirectoryNamed: directoryNameOrPath.
    directory
        forceNewFileNamed: fileName , ext
        do: [ :file | 
            file lineEndConvention: #'lf'.
            self setFileStream: file.
            visitBlock value ]! !

!MCFileTreeAbstractStWriter methodsFor: 'initialize-release' stamp: 'dkh 4/5/2012 11:15:15'!
writeInitializers
    self
        writeInDirectoryName: self monticelloMetaDirName
        fileName: 'initializers'
        extension: '.st'
        visit: [ 
            stWriter
                writePresentInitializers;
                writeAbsentInitializers ]! !

!MCFileTreeAbstractStWriter methodsFor: 'writing' stamp: 'dkh 4/5/2012 11:15:15'!
writeMethodDefinition: definition
    stWriter visitMethodDefinition: definition! !

!MCFileTreeAbstractStWriter methodsFor: 'initialize-release' stamp: 'dkh 4/5/2012 11:15:15'!
writePropertiesFile
    self
        writeInDirectoryName: '.'
        fileName: ''
        extension: '.filetree'
        visit: [ stWriter writeProperties ]! !

MCFileTreeAbstractStWriter subclass: #MCFileTreeStSnapshotWriter
	instanceVariableNames: 'classDefinitions methodDefinitions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

MCFileTreeStSnapshotWriter subclass: #MCFileTreeStCypressWriter
	instanceVariableNames: 'fileStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

MCFileTreeStCypressWriter class
	instanceVariableNames: 'specials'!

!MCFileTreeStCypressWriter class methodsFor: 'private' stamp: 'dkh 4/5/2012 11:15:15'!
initializeSpecials
    | map |
    map := Dictionary new.
    map
        at: $+ put: 'plus';
        at: $- put: 'minus';
        at: $= put: 'equals';
        at: $< put: 'less';
        at: $> put: 'more';
        at: $% put: 'percent';
        at: $& put: 'and';
        at: $| put: 'pipe';
        at: $* put: 'star';
        at: $/ put: 'slash';
        at: $\ put: 'backslash';
        at: $~ put: 'tilde';
        at: $? put: 'wat';
        at: $@ put: 'at'.
    map keys do: [ :key | map at: (map at: key) put: key ].
    ^ map! !

!MCFileTreeStCypressWriter class methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
monticelloMetaDirName
    ^ 'monticello.meta'! !

!MCFileTreeStCypressWriter class methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
specials
    ^ specials ifNil: [ specials := self initializeSpecials ]! !

!MCFileTreeStCypressWriter methodsFor: 'private' stamp: 'dkh 4/5/2012 11:15:15'!
fileNameForSelector: selector
    ^ selector last = $:
        ifTrue: [ 
            selector
                collect: [ :each | 
                    each = $:
                        ifTrue: [ $. ]
                        ifFalse: [ each ] ] ]
        ifFalse: [ 
            selector first isLetter
                ifTrue: [ selector ]
                ifFalse: [ 
                    | output specials |
                    specials := self class specials.
                    output := String new writeStream.
                    output nextPut: $^.
                    selector do: [ :each | output nextPutAll: (specials at: each) ] separatedBy: [ output nextPut: $. ].
                    output contents ] ]! !

!MCFileTreeStCypressWriter methodsFor: 'private' stamp: 'dkh 4/5/2012 11:15:15'!
setFileStream: aStream
    super setFileStream: aStream.
    fileStream := aStream! !

!MCFileTreeStCypressWriter methodsFor: 'writing' stamp: 'dkh 4/5/2012 11:15:15'!
writeClassComment: definition
    fileStream nextPutAll: definition comment withUnixLineEndings! !

!MCFileTreeStCypressWriter methodsFor: 'writing' stamp: 'dkh 4/5/2012 11:15:15'!
writeClassDefinition: definition
    | properties |
    properties := Dictionary new.
    properties at: 'name' put: definition className.
    properties at: 'super' put: definition superclassName.
    definition traitComposition ifNotNil: [ :property | properties at: 'traitcomposition' put: property ].
    definition classTraitComposition ifNotNil: [ :property | properties at: 'classtraitcomposition' put: property ].
    properties at: 'category' put: definition category.
    properties at: 'instvars' put: definition instVarNames asArray.
    properties at: 'classvars' put: definition classVarNames asArray.
    properties at: 'pools' put: definition poolDictionaries asArray.
    properties at: 'classinstvars' put: definition classInstVarNames asArray.
    properties at: 'type' put: definition type asString.
    properties at: 'commentStamp' put: definition commentStamp.
    properties writeCypressJsonOn: fileStream! !

!MCFileTreeStCypressWriter methodsFor: 'writing' stamp: 'dkh 4/5/2012 11:15:15'!
writeClassDefinition: definition to: classPath
    self
        writeInDirectoryName: classPath
        fileName: 'README'
        extension: '.md'
        visit: [ self writeClassComment: definition ].
    self
        writeInDirectoryName: classPath
        fileName: 'properties'
        extension: '.json'
        visit: [ self writeClassDefinition: definition ]! !

!MCFileTreeStCypressWriter methodsFor: 'initialize-release' stamp: 'dkh 4/5/2012 11:15:15'!
writeDefinitions: aCollection
    | classDirExtension extensionClasses extensionMethodDefinitions |
    self writeBasicDefinitions: aCollection.
    extensionClasses := OrderedCollection new.
    extensionMethodDefinitions := OrderedCollection new.
    self methodDefinitions
        keysAndValuesDo: [ :className :extensionMethods | 
            self classDefinitions
                at: className
                ifAbsent: [ 
                    extensionClasses add: className.
                    extensionMethodDefinitions addAll: extensionMethods ] ].
    extensionClasses do: [ :className | self methodDefinitions removeKey: className ].
    classDirExtension := '.class'.
    self classDefinitions
        keysAndValuesDo: [ :className :definition | 
            | classPath instanceMethodPath classMethodPath |
            classPath := definition className , classDirExtension , FileDirectory slash.
            self writeClassDefinition: definition to: classPath.
            instanceMethodPath := classPath , 'instance' , FileDirectory slash.
            classMethodPath := classPath , 'class' , FileDirectory slash.
            (self methodDefinitions at: className ifAbsent: [ #() ])
                do: [ :methodDefinition | 
                    methodDefinition classIsMeta
                        ifTrue: [ self writeMethodDefinition: methodDefinition to: classMethodPath ]
                        ifFalse: [ self writeMethodDefinition: methodDefinition to: instanceMethodPath ] ] ].
    classDirExtension := '.extension'.
    extensionMethodDefinitions
        do: [ :methodDefinition | 
            | classPath methodPath |
            classPath := methodDefinition className , classDirExtension , FileDirectory slash.
            self writeExtensionClassDefinition: methodDefinition to: classPath.
            methodPath := classPath
                ,
                    (methodDefinition classIsMeta
                        ifTrue: [ 'class' ]
                        ifFalse: [ 'instance' ]) , FileDirectory slash.
            self writeMethodDefinition: methodDefinition to: methodPath ]! !

!MCFileTreeStCypressWriter methodsFor: 'writing' stamp: 'dkh 4/5/2012 11:15:15'!
writeExtensionClassDefinition: definition
    | properties |
    properties := Dictionary new.
    properties at: 'name' put: definition className.
    properties writeCypressJsonOn: fileStream! !

!MCFileTreeStCypressWriter methodsFor: 'writing' stamp: 'dkh 4/5/2012 11:15:15'!
writeExtensionClassDefinition: definition to: classPath
    self
        writeInDirectoryName: classPath
        fileName: 'properties'
        extension: '.json'
        visit: [ self writeExtensionClassDefinition: definition ]! !

!MCFileTreeStCypressWriter methodsFor: 'writing' stamp: 'dkh 4/5/2012 11:15:15'!
writeMethodDefinition: definition
    fileStream
        nextPutAll: definition category;
        lf;
        nextPutAll: definition source withUnixLineEndings! !

!MCFileTreeStCypressWriter methodsFor: 'writing' stamp: 'dkh 4/5/2012 11:15:15'!
writeMethodDefinition: methodDefinition to: methodPath
    | filename |
    filename := self fileNameForSelector: methodDefinition selector.
    self
        writeInDirectoryName: methodPath
        fileName: filename
        extension: '.st'
        visit: [ self writeMethodDefinition: methodDefinition ]! !

!MCFileTreeStCypressWriter methodsFor: 'initialize-release' stamp: 'dkh 4/5/2012 11:15:15'!
writePropertiesFile
    | properties |
    properties := Dictionary new.
    properties at: 'noMethodMetaData' put: true.
    properties at: 'separateMethodMetaAndSource' put: false.
    properties at: 'useCypressPropertiesFile' put: true.
    self
        writeInDirectoryName: '.'
        fileName: ''
        extension: '.filetree'
        visit: [ properties writeCypressJsonOn: fileStream ].
    self
        writeInDirectoryName: '.'
        fileName: 'properties'
        extension: '.json'
        visit: [ Dictionary new writeCypressJsonOn: fileStream ]! !

!MCFileTreeStSnapshotWriter methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
classDefinitions
    classDefinitions ifNil: [ classDefinitions := Dictionary new ].
    ^ classDefinitions! !

!MCFileTreeStSnapshotWriter methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
methodDefinitions
    methodDefinitions ifNil: [ methodDefinitions := Dictionary new ].
    ^ methodDefinitions! !

!MCFileTreeStSnapshotWriter methodsFor: 'visiting' stamp: 'dkh 4/5/2012 11:15:15'!
visitClassDefinition: definition
    orderedClassNames add: definition className.
    self classDefinitions at: definition className put: definition! !

!MCFileTreeStSnapshotWriter methodsFor: 'visiting' stamp: 'dkh 4/5/2012 11:15:15'!
visitMethodDefinition: definition
    (self methodDefinitions
        at: definition className
        ifAbsent: [ self methodDefinitions at: definition className put: OrderedCollection new ]) add: definition! !

!MCFileTreeStSnapshotWriter methodsFor: 'writing' stamp: 'dkh 4/5/2012 11:15:15'!
writeClassDefinition: definition to: classPath
    self
        writeInDirectoryName: classPath
        fileName: definition className
        extension: '.st'
        visit: [ self writeClassDefinition: definition ]! !

!MCFileTreeStSnapshotWriter methodsFor: 'initialize-release' stamp: 'dkh 4/5/2012 11:15:15'!
writeDefinitions: aCollection
    | basePath extensionClasses extensionMethodDefinitions |
    self writeBasicDefinitions: aCollection.
    basePath := 'snapshot' , FileDirectory slash , 'classes' , FileDirectory slash.
    extensionClasses := OrderedCollection new.
    extensionMethodDefinitions := OrderedCollection new.
    self methodDefinitions
        keysAndValuesDo: [ :className :extensionMethods | 
            self classDefinitions
                at: className
                ifAbsent: [ 
                    extensionClasses add: className.
                    extensionMethodDefinitions addAll: extensionMethods ] ].
    extensionClasses do: [ :className | self methodDefinitions removeKey: className ].
    self classDefinitions
        keysAndValuesDo: [ :className :definition | 
            | classPath instanceMethodPath classMethodPath |
            classPath := basePath , definition className , '.class' , FileDirectory slash.
            self writeClassDefinition: definition to: classPath.
            instanceMethodPath := classPath , 'instance' , FileDirectory slash.
            classMethodPath := classPath , 'class' , FileDirectory slash.
            (self methodDefinitions at: className ifAbsent: [ #() ])
                do: [ :methodDefinition | 
                    methodDefinition classIsMeta
                        ifTrue: [ self writeMethodDefinition: methodDefinition to: classMethodPath ]
                        ifFalse: [ self writeMethodDefinition: methodDefinition to: instanceMethodPath ] ] ].
    basePath := 'snapshot' , FileDirectory slash , 'extensions' , FileDirectory slash.
    extensionMethodDefinitions
        do: [ :methodDefinition | 
            | methodPath |
            methodPath := basePath , methodDefinition className , '.class' , FileDirectory slash
                ,
                    (methodDefinition classIsMeta
                        ifTrue: [ 'class' ]
                        ifFalse: [ 'instance' ]) , FileDirectory slash.
            self writeMethodDefinition: methodDefinition to: methodPath ]! !

!MCFileTreeStSnapshotWriter methodsFor: 'writing' stamp: 'dkh 4/5/2012 11:15:15'!
writeMethodDefinition: methodDefinition to: methodPath
    | filename |
    filename := self fileNameForSelector: methodDefinition selector.
    self
        writeInDirectoryName: methodPath
        fileName: filename
        extension: '.st'
        visit: [ self writeMethodDefinition: methodDefinition ]! !

MCFileTreeAbstractStWriter subclass: #MCFileTreeStWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

!MCFileTreeStWriter class methodsFor: 'accessing' stamp: 'ezra 11/1/2011 17:52'!
readerClass
	^ MCStReader! !

!MCFileTreeStWriter methodsFor: 'initialize-release' stamp: 'ezra 10/26/2011 17:16'!
initialize
	stWriter := (MCStWriter new)
		initializers: (initializers := Set new);
		yourself.
	orderedClassNames := OrderedCollection new! !

!MCFileTreeStWriter methodsFor: 'visiting' stamp: 'dkh 4/5/2012 11:15:15'!
visitClassDefinition: definition
    orderedClassNames add: definition className.
    self
        writeInDirectoryName: definition className
        fileName: definition className
        extension: '.st'
        visit: [ self writeClassDefinition: definition ]! !

!MCFileTreeStWriter methodsFor: 'visiting' stamp: 'dkh 1/30/2012 16:30'!
visitClassTraitDefinition: definition
    self flag: #'skippedForNow'! !

!MCFileTreeStWriter methodsFor: 'visiting' stamp: 'ezra 10/26/2011 17:37'!
visitMetaclassDefinition: definition
	self
		writeInDirectoryName: definition className , '_class'
		fileName: definition className
		visit: [ stWriter writeMetaclassDefinition: definition ]! !

!MCFileTreeStWriter methodsFor: 'visiting' stamp: 'dkh 4/5/2012 11:15:15'!
visitMethodDefinition: definition
    | filename directoryname |
    directoryname := definition classIsMeta
        ifTrue: [ definition className , '_class' ]
        ifFalse: [ definition className ].
    filename := self fileNameForSelector: definition selector.
    self
        writeInDirectoryName: directoryname
        fileName: filename
        extension: '.st'
        visit: [ self writeMethodDefinition: definition ]! !

!MCFileTreeStWriter methodsFor: 'visiting' stamp: 'OttoBehrens 10/25/2011 12:55'!
visitOrganizationDefinition: defintion
	self
		writeInDirectoryName: '.'
		fileName: 'categories'
		visit: [ defintion categories do: [ :cat | stWriter writeCategory: cat ] ]! !

!MCFileTreeStWriter methodsFor: 'visiting' stamp: 'dkh 1/30/2012 16:30'!
visitScriptDefinition: definition
    self flag: #'skippedForNow'! !

!MCFileTreeStWriter methodsFor: 'visiting' stamp: 'dkh 1/30/2012 16:31'!
visitTraitDefinition: definition
    self flag: #'skippedForNow'! !

!MCFileTreeStWriter methodsFor: 'initialize-release' stamp: 'ezra 5/13/2005 15:15'!
writeDefinitions: aCollection
	"the correct initialization order is unknown if some classes are missing in the image"

	[ 
	stWriter acceptVisitor: self forDefinitions: aCollection.
	self writeInitializers ] on: Error do: [ :ex | ex halt ]! !

!MCFileTreeStWriter methodsFor: 'visiting' stamp: 'ezra 10/25/2011 17:49'!
writeInDirectoryName: directoryName fileName: fileName visit: visitBlock
	(directoryName = '.'
		ifTrue: [ stream packageFileDirectory ]
		ifFalse: [ stream subPackageFileDirectoryFor: directoryName ])
		forceNewFileNamed: fileName
		do: [ :file | 
			file lineEndConvention: #lf.
			stWriter stream: file.
			visitBlock value ]! !

!MCFileTreeStWriter methodsFor: 'initialize-release' stamp: 'ezra 10/26/2011 17:43'!
writeInitializers
	self
		writeInDirectoryName: '.'
		fileName: 'initializers'
		visit: [ 
			stWriter
				writePresentInitializers;
				writeAbsentInitializers ]! !

!MCMethodDefinition methodsFor: '*monticellofiletree-core' stamp: 'dkh 4/5/2012 11:15:15'!
setTimeStamp: aString
    ^ timeStamp := aString! !

MCStWriter subclass: #MCFileTreePackageStructureStWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

!MCFileTreePackageStructureStWriter class methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
useCypressWriter
    "MCFileTreeRepository defaultPackageExtension:'.package'"

    "MCFileTreeRepository defaultPackageExtension:'.pkg'"

    ^ true! !

!MCFileTreePackageStructureStWriter class methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
useSnapShotWriter
    ^ MCFileTreeRepository defaultPackageExtension = '.pkg'! !

!MCFileTreePackageStructureStWriter methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
absentInitializers
	^ initializers reject: [ :each | Smalltalk hasClassNamed: each key ]! !

!MCFileTreePackageStructureStWriter methodsFor: 'visiting' stamp: 'dkh 4/5/2012 11:15:15'!
acceptVisitor: aVisitor forDefinitions: aCollection
	(MCDependencySorter sortItems: aCollection)
		do: [ :ea | ea accept: aVisitor ]
		displayingProgress: 'Writing definitions...'! !

!MCFileTreePackageStructureStWriter methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
initializers: aCollection
	initializers := aCollection! !

!MCFileTreePackageStructureStWriter methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
presentInitializers
	^ initializers select: [ :each | Smalltalk hasClassNamed: each key ]! !

!MCFileTreePackageStructureStWriter methodsFor: 'writing' stamp: 'dkh 4/5/2012 11:15:15'!
writeAbsentInitializers
	(self absentInitializers asSortedCollection: [ :a :b | a key <= b key ])
		do: [ :association | stream nextPutAll: association value contents ]! !

!MCFileTreePackageStructureStWriter methodsFor: 'writing' stamp: 'dkh 4/5/2012 11:15:15'!
writeClassDefinition: definition
    self chunkContents: [ :s | definition printDefinitionOn: s ]! !

!MCFileTreePackageStructureStWriter methodsFor: 'writing' stamp: 'dkh 4/5/2012 11:15:15'!
writeDefinitions: aCollection
	"the correct initialization order is unknown if some classes are missing in the image"

	initializers := Set new.
	self
		acceptVisitor: self forDefinitions: aCollection;
		writePresentInitializers;
		writeAbsentInitializers! !

!MCFileTreePackageStructureStWriter methodsFor: 'writing' stamp: 'dkh 4/5/2012 11:15:15'!
writeMethodPreamble: definition
    stream
        cr;
        nextPut: $!!;
        nextPutAll: definition fullClassName;
        nextPutAll: ' methodsFor: ';
        nextPutAll: definition category asString printString;
        nextPutAll: '!!';
        cr! !

!MCFileTreePackageStructureStWriter methodsFor: 'writing' stamp: 'dkh 4/5/2012 11:15:15'!
writePresentInitializers
	| orderedClasses presentInitializers |
	presentInitializers := self presentInitializers.
	orderedClasses := (Class
		superclassOrder: (presentInitializers collect: [ :each | Smalltalk classOrTraitNamed: each key ]))
		collect: [ :each | each name ].
	orderedClasses
		do: [ :className | stream nextPutAll: (presentInitializers detect: [ :each | each key = className ]) value contents ]! !

!MCFileTreePackageStructureStWriter methodsFor: 'writing' stamp: 'dkh 4/5/2012 11:15:15'!
writeProperties
    stream
        nextPut: ${;
        cr;
        nextPutAll: '    "noMethodMetaData" : true,';
        cr;
        nextPutAll: '    "separateMethodMetaAndSource" : false';
        cr;
        nextPut: $};
        cr! !

!Boolean methodsFor: '*monticellofiletree-core' stamp: 'dkh 4/6/2012 15:56:14'!
writeCypressJsonOn: aStream forHtml: forHtml indent: startIndent
    "by default ignore <forHtml> ... <forHtml> is used for Dictionary and Array, i.e., container objects and String which actually encodes itself differently for HTML"

    aStream nextPutAll: self printString! !

MCMczReader subclass: #MCFileTreeAbstractReader
	instanceVariableNames: 'packageDirectory packageProperties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

!MCFileTreeAbstractReader class methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
monticelloMetaDirName
    ^ '.'! !

!MCFileTreeAbstractReader class methodsFor: 'reading' stamp: 'dkh 4/5/2012 11:15:15'!
on: s fileName: f
	^ (self on: s)
		packageDirectory: f;
		yourself! !

!MCFileTreeAbstractReader methodsFor: 'utilities' stamp: 'dkh 4/5/2012 11:15:15'!
addClassAndMethodDefinitionsFromDirectory: aDirectory
    self subclassResponsibility! !

!MCFileTreeAbstractReader methodsFor: 'utilities' stamp: 'dkh 4/5/2012 11:15:15'!
addClassAndMethodDefinitionsFromDirectoryEntries: entries
    | timestamp |
    self noMethodMetaData
        ifTrue: [ timestamp := self info author , ' ' , self info date mmddyyyy , ' ' , self info time print24 ].
    entries
        do: [ :element | 
            element isDirectory
                ifTrue: [ 
                    | directory |
                    directory := element asFileDirectory.
                    ((self separateMethodMetaAndSource or: [ self noMethodMetaData ])
                        ifTrue: [ directory entries select: [ :entry | entry name endsWith: '.st' ] ]
                        ifFalse: [ directory entries ])
                        do: [ :file | 
                            | definition |
                            (definition := self definitionFromFile: file inDirectory: directory)
                                ifNotNil: [ 
                                    definition isMethodDefinition
                                        ifTrue: [ 
                                            self separateMethodMetaAndSource
                                                ifTrue: [ 
                                                    directory
                                                        fileNamed: definition selector asString , '.meta'
                                                        do: [ :fileStream | definition setTimeStamp: (Author fixStamp: fileStream contents) ] ].
                                            self noMethodMetaData
                                                ifTrue: [ definition setTimeStamp: timestamp ] ].
                                    definitions add: definition ] ] ] ]! !

!MCFileTreeAbstractReader methodsFor: 'utilities' stamp: 'dkh 4/5/2012 11:15:15'!
addDefinitionFromFile: directoryEntry inDirectory: aDirectory
    (self definitionFromFile: directoryEntry inDirectory: aDirectory) ifNotNil: [ :def | definitions add: def ]! !

!MCFileTreeAbstractReader methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
basicVersion
	^ (MCVersion new)
		setPackage: self package
			info: self info
			snapshot: self snapshot
			dependencies: self dependencies;
		yourself! !

!MCFileTreeAbstractReader methodsFor: 'utilities' stamp: 'dkh 4/5/2012 11:15:15'!
definitionFromFile: directoryEntry inDirectory: aDirectory
    | defs reader |
    directoryEntry ifNil: [ ^ nil ].
    aDirectory
        fileNamed: directoryEntry name
        do: [ :fileStream | 
            | methodDefinition |
            reader := MCStReader on: fileStream.
            (defs := reader definitions) size <= 1
                ifFalse: [ self error: 'we should be writing exactly 1 definition per file' ] ].
    defs size = 0
        ifTrue: [ ^ nil ].
    ^ defs first! !

!MCFileTreeAbstractReader methodsFor: 'utilities' stamp: 'dkh 4/5/2012 11:15:15'!
loadDefinitions
    | entries |
    definitions := OrderedCollection new.
    entries := packageDirectory entries.
    self
        addDefinitionFromFile: (entries detect: [ :entry | entry name beginsWith: 'categories' ] ifNone: [  ])
            inDirectory: packageDirectory;
        addClassAndMethodDefinitionsFromDirectory: packageDirectory;
        addDefinitionFromFile: (entries detect: [ :entry | entry name beginsWith: 'initializers' ] ifNone: [  ])
            inDirectory: packageDirectory! !

!MCFileTreeAbstractReader methodsFor: 'utilities' stamp: 'dkh 4/5/2012 11:15:15'!
loadDependencies
	dependencies := Array new! !

!MCFileTreeAbstractReader methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
monticelloMetaDirName
    ^ self class monticelloMetaDirName! !

!MCFileTreeAbstractReader methodsFor: 'testing' stamp: 'dkh 4/5/2012 11:15:15'!
noMethodMetaData
    ^ self packageProperties at: 'noMethodMetaData' ifAbsent: [ false ]! !

!MCFileTreeAbstractReader methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
packageDirectory: aByteString
	packageDirectory := stream directoryNamed: aByteString! !

!MCFileTreeAbstractReader methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
packageProperties
    packageProperties
        ifNil: [ 
            packageProperties := Dictionary new.
            (packageDirectory entries detect: [ :entry | entry name = '.filetree' ] ifNone: [  ])
                ifNotNil: [ :configEntry | 
                    configEntry
                        readStreamDo: [ :fileStream | 
                            | jsonObject structureVersion |
                            [ 
                            (jsonObject := MCFileTreeJsonParser parseStream: fileStream) isFloat
                                ifTrue: [ 
                                    "
							0.0 - original structure
							0.1 - separate files for method metaData (timestamp) and source
							0.2 - no method metaData file"
                                    packageProperties := Dictionary new.
                                    structureVersion := jsonObject printShowingDecimalPlaces: 1.
                                    packageProperties at: 'noMethodMetaData' put: structureVersion = '0.2'.
                                    packageProperties at: 'separateMethodMetaAndSource' put: structureVersion = '0.1' ]
                                ifFalse: [ 
                                    packageProperties := jsonObject.
                                    ((packageProperties at: 'noMethodMetaData' ifAbsent: [ false ])
                                        and: [ packageProperties at: 'separateMethodMetaAndSource' ifAbsent: [ false ] ])
                                        ifTrue: [ self error: 'noMethodMetaData and separateMethodMetaAndSource cannot both be true' ] ] ]
                                on: Error
                                do: [ :ex | 
                                    Transcript
                                        cr;
                                        show:
                                                'Error reading package properties (.filetree): ' , packageDirectory pathName , ' :: ' , ex description ] ] ] ].
    ^ packageProperties! !

!MCFileTreeAbstractReader methodsFor: 'utilities' stamp: 'dkh 4/5/2012 11:15:15'!
parseMember: fileName
    | directory tokens contents |
    directory := packageDirectory directoryNamed: self monticelloMetaDirName.
    contents := directory fileNamed: fileName do: [ :file | file contents ].
    tokens := (self scanner scanTokens: contents) first.
    ^ self associate: tokens! !

!MCFileTreeAbstractReader methodsFor: 'testing' stamp: 'dkh 4/5/2012 11:15:15'!
separateMethodMetaAndSource
    ^ self packageProperties at: 'separateMethodMetaAndSource' ifAbsent: [ false ]! !

MCFileTreeAbstractReader subclass: #MCFileTreeStReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

!MCFileTreeStReader class methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
extension
	^ 'tree'! !

!MCFileTreeStReader methodsFor: 'utilities' stamp: 'dkh 4/5/2012 11:15:15'!
addClassAndMethodDefinitionsFromDirectory: aDirectory
    self addClassAndMethodDefinitionsFromDirectoryEntries: aDirectory entries! !

MCFileTreeAbstractReader subclass: #MCFileTreeStSnapshotReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

MCFileTreeStSnapshotReader subclass: #MCFileTreeStCypressReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

!MCFileTreeStCypressReader class methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
extension
    ^ 'package'! !

!MCFileTreeStCypressReader class methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
monticelloMetaDirName
    ^ MCFileTreeStCypressWriter monticelloMetaDirName! !

!MCFileTreeStCypressReader methodsFor: 'utilities' stamp: 'dkh 4/5/2012 11:15:15'!
addClassAndMethodDefinitionsFromDirectory: aDirectory
    aDirectory entries
        do: [ :entry | 
            (entry name endsWith: '.class')
                ifTrue: [ self addClassAndMethodDefinitionsFromEntry: entry ].
            (entry name endsWith: '.extension')
                ifTrue: [ self addExtensionClassAndMethodDefinitionsFromEntry: entry ] ]! !

!MCFileTreeStCypressReader methodsFor: 'utilities' stamp: 'dkh 4/5/2012 11:15:15'!
addClassAndMethodDefinitionsFromEntry: classEntry
    | classDirectory classPropertiesDict classComment entries |
    classDirectory := classEntry asFileDirectory.
    ((entries := classDirectory entries) detect: [ :entry | entry name = 'properties.json' ] ifNone: [  ])
        ifNotNil: [ :propertyEntry | propertyEntry readStreamDo: [ :fileStream | classPropertiesDict := MCFileTreeJsonParser parseStream: fileStream ] ].
    (entries detect: [ :entry | entry name = 'README.md' ] ifNone: [  ])
        ifNotNil: [ :commentEntry | commentEntry readStreamDo: [ :fileStream | classComment := fileStream contents ] ].
    self addClassDefinitionFrom: classPropertiesDict comment: classComment.
    self addMethodDefinitionsForClass: (classPropertiesDict at: 'name') in: entries! !

!MCFileTreeStCypressReader methodsFor: 'utilities' stamp: 'dkh 4/5/2012 11:15:15'!
addClassDefinitionFrom: classPropertiesDict comment: classComment
    definitions
        add:
            (MCClassDefinition
                name: (classPropertiesDict at: 'name')
                superclassName: (classPropertiesDict at: 'super')
                traitComposition: (classPropertiesDict at: 'traitcomposition' ifAbsent: [ '{}' ])
                classTraitComposition: (classPropertiesDict at: 'classtraitcomposition' ifAbsent: [ '{}' ])
                category: (classPropertiesDict at: 'category')
                instVarNames: (classPropertiesDict at: 'instvars' ifAbsent: [ #() ])
                classVarNames: (classPropertiesDict at: 'classvars' ifAbsent: [ #() ])
                poolDictionaryNames: (classPropertiesDict at: 'pools' ifAbsent: [ #() ])
                classInstVarNames: (classPropertiesDict at: 'classinstvars' ifAbsent: [ #() ])
                type: (classPropertiesDict at: 'type' ifAbsent: [ 'normal' ]) asSymbol
                comment: classComment
                commentStamp: (classPropertiesDict at: 'commentStamp' ifAbsent: [ '' ]))! !

!MCFileTreeStCypressReader methodsFor: 'utilities' stamp: 'dkh 4/5/2012 11:15:15'!
addExtensionClassAndMethodDefinitionsFromEntry: classEntry
    | classDirectory classPropertiesDict entries |
    classDirectory := classEntry asFileDirectory.
    ((entries := classDirectory entries) detect: [ :entry | entry name = 'properties.json' ] ifNone: [  ])
        ifNotNil: [ :propertyEntry | propertyEntry readStreamDo: [ :fileStream | classPropertiesDict := MCFileTreeJsonParser parseStream: fileStream ] ].
    self addMethodDefinitionsForClass: (classPropertiesDict at: 'name') in: entries! !

!MCFileTreeStCypressReader methodsFor: 'utilities' stamp: 'dkh 4/5/2012 11:15:15'!
addMethodDefinitionsForClass: className in: entries
    entries
        do: [ :entry | 
            | classIsMeta |
            classIsMeta := false.
		entry name = 'class'
                ifTrue: [ classIsMeta := true ].
            (entry name = 'instance' or: [ entry name = 'class' ])
                ifTrue: [ 
                    (entry asFileDirectory entries select: [ :each | each name endsWith: '.st' ])
                        do: [ :methodEntry | 
                            methodEntry
                                readStreamDo: [ :fileStream | 
                                    | category source timestamp |
                                    category := fileStream nextLine.
                                    source := fileStream upToEnd.
                                    timestamp := self info author , ' ' , self info date mmddyyyy , ' '
                                        , self info time print24.
                                    definitions
                                        add:
                                            (MCMethodDefinition
                                                className: className
                                                classIsMeta: classIsMeta
                                                selector: (self methodSelectorFor: source)
                                                category: category
                                                timeStamp: timestamp
                                                source: source) ] ] ] ]! !

!MCFileTreeStCypressReader methodsFor: 'utilities' stamp: 'dkh 4/5/2012 11:15:15'!
loadDefinitions
    | entries directory |
    definitions := OrderedCollection new.
    directory := packageDirectory directoryNamed: self monticelloMetaDirName.
    entries := directory entries.
    self
        addDefinitionFromFile: (entries detect: [ :entry | entry name beginsWith: 'categories' ] ifNone: [  ])
            inDirectory: directory;
        addClassAndMethodDefinitionsFromDirectory: packageDirectory;
        addDefinitionFromFile: (entries detect: [ :entry | entry name beginsWith: 'initializers' ] ifNone: [  ])
            inDirectory: directory! !

!MCFileTreeStCypressReader methodsFor: 'utilities' stamp: 'dkh 4/5/2012 11:15:15'!
methodSelectorFor: source
    ^ Object parserClass new parseSelector: source! !

!MCFileTreeStSnapshotReader class methodsFor: 'accessing' stamp: 'dkh 4/5/2012 11:15:15'!
extension
    ^ 'pkg'! !

!MCFileTreeStSnapshotReader methodsFor: 'utilities' stamp: 'dkh 4/5/2012 11:15:15'!
addClassAndMethodDefinitionsFromDirectory: aDirectory
    | snapshot classes entries extensions |
    snapshot := aDirectory directoryNamed: 'snapshot'.
    classes := snapshot directoryNamed: 'classes'.
    classes exists
        ifTrue: [ 
            self addClassAndMethodDefinitionsFromDirectoryEntries: (entries := classes entries).	"load .st files from subdirectories (*.class) of snapshot/classes ... class defintions"
            entries
                do: [ :classDirectoryEntry | 
                    | classDirectory |
                    classDirectory := classDirectoryEntry asFileDirectory.
                    self addClassAndMethodDefinitionsFromDirectoryEntries: classDirectory entries	"load .st files from subdirectories (class or instance) of snapshot/classes/*.class ... method definitions" ] ].
    extensions := snapshot directoryNamed: 'extensions'.
    extensions exists
        ifTrue: [ 
           extensions entries
                do: [ :classDirectoryEntry | 
                    | classDirectory |
                    classDirectory := classDirectoryEntry asFileDirectory.
                    self addClassAndMethodDefinitionsFromDirectoryEntries: classDirectory entries	"load .st files from subdirectories (class or instance) of snapshot/extensions/*.class ... method definitions" ] ].
! !
